<?php

namespace app\api\controller\school\worker;


use app\common\model\school\classes\hourorder\Order as OrderModel;
use app\common\model\school\classes\order\Order as ClassesOrderModel;

/**
 * 员工端：课时订单管理接口
 */
class HourOrder extends Base
{
    protected $noNeedLogin = [];
    protected $noNeedRight = '*';

    protected $model = null;


    /**
     * 初始化操作
     * @access protected
     */
    protected function _initialize()
    {

        $this->model = new OrderModel;
        parent::_initialize();

        //判断登录用户是否是员工
        $this->setUrlLock();
    }






    /**
     * @ApiTitle( 员工代下单：订单确认/订单计算接口)
     * @ApiSummary(订单确认/订单计算接口【有过期时间】)
     * @ApiRoute(/api/school/worker/hour_order/confirm)
     * @ApiMethod(POST)
     * @ApiParams(name = "classes_order_id", type = "int",required=true,description = "课程订单id")
     * @ApiParams(name = "classes_lib_spec_id", type = "int",required=false,description = "课时规格id")
     * @ApiParams(name = "order_no", type = "string",required=false,description = "缓存key")
     * @ApiParams(name = "is_compute", type = "int",required=false,description = "是否重新计算并更新缓存 默认传1")
     * @ApiReturn({
     *
     *})
     */
    public function confirm(){
        $user_id = 0;
        $user = $this->auth->getUser();//登录用户
        if($user)$user_id = $user['id'];
        $classes_order_id =  $this->request->post('classes_order_id/d', 0); //课程id
        $classes_lib_spec_id =  $this->request->post('classes_lib_spec_id/d', 0); //课程id
        //记录代下单人信息
        $param  =  [
            "type" =>'2',
            "help_user_id" =>$user_id,
            "help_type" => 'user',
        ]; //参数
        $order_no  =  $this->request->post('order_no/s', ''); //订单号
        $is_compute =  $this->request->post('is_compute/d', 1); //是否重新计算并更新缓存
        try{

            //当前申请状态
            $res = $this->model->confirm($user_id, $classes_order_id,$order_no,$classes_lib_spec_id,$param, $is_compute);
        }catch (\Exception $e){
//            Log::log($e->getMessage());
            $this->error($e->getMessage(),['errcode'=>$e->getCode()]);
        }
        $this->success('执行成功，可用缓存key去预约', $res);
    }


    /**
     * @ApiTitle( 员工代下单：订单下单接口)
     * @ApiSummary(订单下单接口)
     * @ApiRoute(/api/school/worker/hour_order/create)
     * @ApiMethod(POST)
     * @ApiParams(name = "order_no", type = "string",required=true,description = "缓存key")
     * @ApiReturn({
     *
     *})
     */
    public function create(){
        $user_id = 0;
        $user = $this->auth->getUser();//登录用户
        if($user)$user_id = $user['id'];
        $order_no =  $this->request->post('order_no/s', ''); //订单号
        $remark =  $this->request->post('remark/s', ''); //下单备注
//        repeat_filter("appointment\order\create".$user_id, 2);
        $this->setUrlLock("only");
        try{
            //当前申请状态
            $res = $this->model->cacheCreateOrder($order_no, $user_id,$remark, true);
        }catch (\Throwable $e){
//            file_put_contents("test.txt",$e->getMessage().$e->getFile().$e->getLine());//写入文件，一般做正式环境测试
//            Log::log($e->getMessage());
            $this->error($e->getMessage(),['errcode'=>$e->getCode()]);;
        }
        $this->success('订单创建成功，缓存key被消耗', $res);
    }





    /**
     * @ApiTitle( 员工代操作：预约课时单取消接口)
     * @ApiSummary(预约课时单取消接口（已完成的单无法取消）)
     * @ApiRoute(/api/school/worker/hour_order/cancel)
     * @ApiMethod(POST)
     * @ApiParams(name = "order_no", type = "string",required=true,description = "订单号")
     * @ApiReturn({
     *
     *})
     */
    public function cancel(){
        $user_id = 0;
        $user = $this->auth->getUser();//登录用户
        if($user)$user_id = $user['id'];
        $order_no =  $this->request->post('order_no/s', ''); //订单号
        try{
            //当前申请状态
            $res = $this->model->cancel($order_no,0,true,'user',$user_id,true);
        }catch (\Throwable $e){
            $this->error($e->getMessage());
        }
        $this->success('预约课时取消成功', $res);
    }






    /**
     * @ApiTitle( 员工代操作：预约课时单审核接口)
     * @ApiSummary(预约课时单审核接口)
     * @ApiRoute(/api/school/worker/hour_order/examine)
     * @ApiMethod(POST)
     * @ApiParams(name = "order_no", type = "string",required=true,description = "订单号")
     * @ApiParams(name = "auth_status", type = "int",required=true,description = "审核状态:1=审核通过,2=审核失败")
     * @ApiParams(name = "reason", type = "string",required=false,description = "审核失败理由")
     * @ApiReturn({
     *
     *})
     */
    public function examine(){
        $user_id = 0;
        $user = $this->auth->getUser();//登录用户
        if($user)$user_id = $user['id'];
        $order_no =  $this->request->post('order_no/s', ''); //订单号
        $auth_status =  $this->request->post('auth_status/d', ''); //审核状态
        $reason =  $this->request->post('reason/s', ''); //审核失败理由
        try{
            //当前申请状态
            $res = $this->model->examine($order_no,$auth_status,$reason,0,true,'user',$user_id,true);
        }catch (\Throwable $e){
            $this->error($e->getMessage());
        }
        $this->success('预约课时取消成功', $res);
    }




    /**
     * @ApiTitle( 员工代操作：预约课时单核销完成接口)
     * @ApiSummary(预约课时单核销完成接口)
     * @ApiRoute(/api/school/worker/hour_order/verification)
     * @ApiMethod(POST)
     * @ApiParams(name = "order_no", type = "string",required=true,description = "订单号")
     * @ApiReturn({
     *
     *})
     */
    public function verification(){
        $user_id = 0;
        $user = $this->auth->getUser();//登录用户
        if($user)$user_id = $user['id'];
        $order_no =  $this->request->post('order_no/s', ''); //订单号
        try{
            //当前申请状态
            $res = $this->model->verification($order_no,0,true,'user',$user_id,true);
        }catch (\Throwable $e){
            $this->error($e->getMessage());
        }
        $this->success('预约课时核销成功', $res);
    }






    /**
     * @ApiTitle( 员工代操作：预约课修改课时接口)
     * @ApiSummary(预约课修改课时接口)
     * @ApiRoute(/api/school/worker/hour_order/update_spec)
     * @ApiMethod(POST)
     * @ApiParams(name = "order_no", type = "string",required=true,description = "订单号")
     * @ApiParams(name = "classes_lib_spec_id", type = "int",required=true,description = "要更换的课时id")
     * @ApiReturn({
     *
     *})
     */
    public function update_spec(){
        $user_id = 0;
        $user = $this->auth->getUser();//登录用户
        if($user)$user_id = $user['id'];
        $order_no =  $this->request->post('order_no/s', ''); //订单号
        $classes_lib_spec_id =  $this->request->post('classes_lib_spec_id/d', 0); //审核状态
        try{
            //当前申请状态
            $res = $this->model->updateClassesSpec($order_no,$classes_lib_spec_id,0,true,'user',$user_id,true);
        }catch (\Throwable $e){
            $this->error($e->getMessage());
        }
        $this->success('预约课时取消成功', $res);
    }






    /**
     * @ApiTitle( 课时订单详情)
     * @ApiSummary(课时订单详情)
     * @ApiRoute(/api/school/worker/hour_order/detail)
     * @ApiMethod(GET)
     * @ApiParams(name = "id", type = "int",required=true,description = "订单id或订单号")
     * @ApiReturn({
     *
     *})
     */
    public function detail(){
        $id = $this->request->get('id/d','');

        if(empty($id)){
            $this->error(__('缺少必要参数'));
        }

        try {
            $res =  OrderModel::getDetail($id,$this->classes_lib_ids);
        } catch (\Exception $e){
//            Log::log($e->getMessage());
            $this->error($e->getMessage(),['errcode'=>$e->getCode()]);
        }
        $this->success('获取成功', ['detail' => $res]);
    }





    /**
     * @ApiTitle( 我的课时订单列表接口)
     * @ApiSummary(我的课时订单列表接口)
     * @ApiRoute(/api/school/worker/hour_order/order_list)
     * @ApiMethod(GET)
     * @ApiParams(name = "keywords", type = "string",required=false,description = "搜索关键字")
     * @ApiParams(name = "page", type = "string",required=true,description = "页数")
     * @ApiParams(name = "limit", type = "string",required=true,description = "条数")
     * @ApiParams(name = "status", type = "string",required=false,description = "订单状态:-3=已取消,-1=已报名待审核,0=已预约,3=已完成")
     * @ApiParams(name = "classes_order_id", type = "string",required=false,description = "课程订单id")
     * @ApiParams(name = "classes_lib_id", type = "int",required=false,description = "课程id")
     * @ApiParams(name = "shop_id", type = "int",required=false,description = "机构shopid")
     * @ApiParams(name = "start_time", type = "string",required=false,description = "按开始时间区间查（传值格式：Y/m/d H:M:S-Y/m/d H:M:S）")
     * @ApiParams(name = "createtime", type = "string",required=false,description = "按创建时间区间查（传值格式：Y/m/d H:M:S-Y/m/d H:M:S）")
     * @ApiParams(name = "time", type = "string",required=false,description = "按开始和结束时间区间查（传值格式：Y/m/d H:M:S-Y/m/d H:M:S）")
     * @ApiReturn({
     *
     *})
     */
    public function order_list()
    {

        $user_id = 0;
        $user = $this->auth->getUser();//登录用户
        if($user)$user_id = $user['id'];

        $page  =  $this->request->get('page/d', 0); //页数
        $limit =  $this->request->get('limit/d', 0); //条数
        $keywords =  $this->request->get('keywords/s', ''); //搜索关键字
        $status =  $this->request->get('status/s', ''); //搜索关键字
        $classes_order_id =  $this->request->get('classes_order_id/d', 0); //搜索关键字
        $classes_lib_ids =  $this->request->get('classes_lib_id/s', 0); //搜索关键字
        $shop_id =  $this->request->get('shop_id/d', 0); //搜索关键字

        $start_time =  $this->request->get('start_time/s', ''); //搜索关键字
        $createtime =  $this->request->get('createtime/s', ''); //搜索关键字
        $time =  $this->request->get('time/s', ''); //搜索关键字

//        $type =  $this->request->get('type/s', ''); //筛选学员和教练单
//        var_dump($this->classes_lib_ids);die;
        try{
            //当前申请状态
            $res = $this->model::workList($page, $limit,$keywords,$status,$classes_order_id,0,$classes_lib_ids,$this->classes_lib_ids,$start_time,$createtime,$time,$shop_id);
//            var_dump($this->model->getLastSql());die;
//            if($user_id =='670153'){
//               file_put_contents("ceshi66.txt",(new AppointmentOrder())->getLastSql());
//            }
        }catch (\Exception $e){

            $this->error($e->getMessage());
        }
        $this->success('查询成功', $res);
    }


    /**
     * @ApiTitle( 课时订单数量接口)
     * @ApiSummary(课时订单各个数量)
     * @ApiRoute(/api/school/worker/hour_order/order_count)
     * @ApiMethod(GET)
     * @ApiParams(name = "classes_order_id", type = "int",required=true,description = "课程订单id")
     * @ApiParams(name = "classes_lib_id", type = "int",required=false,description = "课程id")
     * @ApiReturn({
     *
     *})
     */
    public function order_count(){


        $classes_order_id =  $this->request->get('classes_order_id/d', 0); //搜索关键字
        $classes_lib_ids =  $this->request->get('classes_lib_id/s', 0); //搜索关键字
        $shop_id =  $this->request->get('shop_id/d', 0); //搜索关键字

        try{
            $res = $this->model::workCount($classes_lib_ids,$this->classes_lib_ids,$classes_order_id,$shop_id);
        }catch (\Throwable $e){
            $this->error($e->getMessage());
        }
        $this->success('查询成功', $res);
    }












}

